<script lang="ts">
import { computed, defineComponent, reactive, ref } from '@vue/composition-api'
import { Order, colors, } from "@/model"
import time from "strftime"
import ChipCounter from '../ChipCounter.vue'
import ChipCard from '../ChipCard.vue'

export default defineComponent({
	components: { ChipCounter, ChipCard },
	props: {
		order: {
			type: Object,
			required: true
		},
		showQueueButton: {
			type: Boolean,
			default: false
		},
		disabled: {
			type: Boolean,
			default: false
		}
	},
	setup(props) {
		const o = computed(() => Order.from(props.order as Order));
		// console.log(o)

		let assigned = computed(() => Object.assign({}, ...colors.map(color => ({ [color]: o.value.countAssigned(color) }))) as { [key: string]: number })
		// let assigned2 = computed(() => colors.reduce((dict, color) => {
		// 	dict[color] = o.value.countAssigned(color)
		// 	return dict
		// }, {} as {[key:string] : number}))

		let assignedChips = computed(() => o.value.assignedChips);

		return {
			o, assigned, assignedChips
		}

	},
})
</script>


<template>
	<v-card>
		<div class="id"> #{{order.id}}</div>
		<div class="ordered">
			<chip-counter v-for="{color, amount} of o.orderedItems" :key="color + amount" 
				v-bind="assignedChips.length === 0 ? {color, amount} : {color, amount: assigned[color], max: amount }" 
				showCounter size="2rem"/>
		</div>

		<v-menu open-on-hover top offset-y>
			<template v-slot:activator="{ on, attrs }">
				<div class="assigned">
					<v-btn v-if="assignedChips.length > 0" plain xx-small v-bind="attrs" v-on="on">
						<v-icon>mdi-dots-horizontal</v-icon>
					</v-btn>
				</div>
			</template>

			<v-list>
				<div class="assigned-item" v-for="({color, rfid}) in assignedChips" :key="rfid">
					<chip-counter v-bind="{color}"></chip-counter>
					<kbd>#{{rfid}}</kbd>
				</div>
			</v-list>
		</v-menu>

		<v-btn
			v-if="showQueueButton"
			:disabled="disabled"
			outlined
			color="primary"
			@click="$emit('queue-order', o.id)"
			>
			Queue order
		</v-btn>
	</v-card>
</template>


<style scoped>
.id {
	font-family: consolas;
	font-style: italic;
	padding-left: 0.5em;
}
.v-card,
.assigned-item,
.ordered {
	display: flex;
	gap: 10px;
	padding: 0.2em;
	align-items: center;
}
.ordered {
	flex-grow: 1;
}
.assigned {
	max-width: 3em;
	flex-grow: 1;
	flex-shrink: 1;
}
.assigned-item {
	justify-content: center;
}
</style>